#!/usr/bin/python
# -*- coding: utf-8 -*-
# Written by Ioannis A. Mourtsiadis info@pimodules.com
# timer based interrupt daemon supporting UPS PIco HV4.0
# Version 2.0 Relase Date 01.01.2021

import sys
import time
import datetime
import os
import re     
import getopt
import smbus
import psutil
import time
import datetime
import threading
import RPi.GPIO as GPIO

#You can install psutil using: sudo pip install psutil
#import psutil

picostat = 0x69
picocmd = 0x6b
pwm_pin = 18
i2c =smbus.SMBus(1)
GPIO.setmode(GPIO.BCM)
GPIO.setup(pwm_pin, GPIO.OUT)

############### FUNCTIONS ###################

def pwm_on(): 
    GPIO.output(pwm_pin, GPIO.HIGH)
    #print ("--------------- DEBUG: PWM ON ---------------")

def pwm_off(): 
    GPIO.output(pwm_pin, GPIO.LOW)
    #print ("--------------- DEBUG: PWM OFF ---------------")

def dec2BCD(inputValue): 
    x=str(inputValue) 
    BCDOut = 0 
    for char in x: 
        BCDOut = (BCDOut << 4) + int(char) 
    return BCDOut

def getCPUtemperature():
    res = os.popen('vcgencmd measure_temp').readline()
    cpu_data=res.replace("temp=","").replace("'C\n","")
    cpu_int=int(float(cpu_data))
    return format(cpu_int,"02d")

def timer_int():
    #print ("--------------- DEBUG: Timer Fired ---------------")
    t=threading.Timer(0.25, timer_int)
    t.start()
    try:
        data = i2c.read_byte_data(picocmd, 0x00)        
        #print "i2c.read_byte_data(picocmd, 0x00)=",data
    except IOError:
        data = 0x00
           
    if(data == 0xcc):
        i2c.write_byte_data(0x6b, 0x00, 0xaa)
        time.sleep(0.5)
        os.system("sudo shutdown -h now")
        time.sleep(60)

    if(data == 0x11):
        i2c.write_byte_data(picocmd, 0x00, 0x00)
        os.system("sudo shutdown -h now") 
        time.sleep(60)
        
    cpu_tmp=dec2BCD(int(getCPUtemperature(),10))
    #print("DEBUG dec2BCD(int(getCPUtemperature(),10)):",dec2BCD(int(getCPUtemperature(),10)))
    #print("DEBUG int(getCPUtemperature(),10):",int(getCPUtemperature(),10))

    try:
        pwr=i2c.read_byte_data(picostat, 0x00)  
    except IOError:    
        pwr = 0xff 
    
    #if pwr==0x00:
    #    pwm_off()
    #else:
    #    pwm_on()
        
    try:
        i2c.write_byte_data(picostat, 0x1a, cpu_tmp) 
    except IOError:    
        data = 0x00 
       

############### MAIN #################    
t = threading.Timer(0.40, timer_int)
t.start()

while True:
   #print("DEBUG: inside of the loop")
   time.sleep(30)








